## mx-packageinstaller 24.8.05

=== debian/changelog ===
mx-packageinstaller (24.8.05) mx; urgency=medium

  * Added an "Autoremovable" item in combo box filter to list autoremovable
    packages in the "Enabled" tab
  * Added option to mark autoremovable packages as "manually installed" to
    prevent them from being autoremoved
  * Renamed "remove orphan packages" to "autoremove packages"
  * Save combo box filter selection when changing tabs
  * Disable MX test and Backports while loading Enabled sources at startup
  * Disable other tabs while a tab is loading

 -- Adrian <adrian@mxlinux.org>  Wed, 31 Jul 2024 22:45:23 -0400

## mx-packageinstaller 24.8.07

=== debian/changelog ===
mx-packageinstaller (24.8.07) mx; urgency=medium

  * Run apt-get --dry-run autoremove as normal user

 -- Adrian <adrian@mxlinux.org>  Sat, 03 Aug 2024 11:42:27 -0400

=== debian/rules ===
#!/usr/bin/make -f
export QT_SELECT=5

QMAKE_OPTS = DEFINES+=NO_DEBUG_ON_CONSOLE
MAKE_OPTS  = QMAKE=qmake-qt5 LRELEASE=lrelease-qt5 QMAKE_OPTS="$(QMAKE_OPTS)"

override_dh_auto_clean:
	dh_auto_clean
	rm -f translations/*.qm
	rm -f src/translations/*.qm

override_dh_auto_build:
	lrelease translations/*.ts
	dh_auto_build -- $(MAKE_OPTS)

override_dh_auto_install:
	dh_auto_install -- $(MAKE_OPTS)

override_dh_shlibdeps:
	dh_shlibdeps -- -xvirtualbox-guest-x11 --ignore-missing-info

%:
	dh $@ --no-automatic-dbgsym --parallel 

override_dh_auto_install:
	dh_auto_install
	dh_link usr/bin/mx-packageinstaller usr/bin/mxpi-launcher

## mx-packageinstaller 24.8.09

=== debian/changelog ===
mx-packageinstaller (24.8.09) mx; urgency=medium

  * Add an Installed Version alongside Repo Version column

 -- Adrian <adrian@mxlinux.org>  Fri, 16 Aug 2024 22:47:13 -0400

## mx-packageinstaller 24.8.10

=== debian/changelog ===
mx-packageinstaller (24.8.10) mx; urgency=medium

  * Remove tooltips that show version since we display them in a separate
    column (reduces CPU and RAM utilization)

 -- Adrian <adrian@mxlinux.org>  Sun, 18 Aug 2024 12:55:29 -0400

## mx-packageinstaller 24.9

=== debian/changelog ===
mx-packageinstaller (24.9) mx; urgency=medium

  * Fix: packages with no description were not listed as installed

 -- Adrian <adrian@mxlinux.org>  Fri, 06 Sep 2024 14:48:35 -0400

## mx-packageinstaller 24.10

=== debian/changelog ===
mx-packageinstaller (24.10) mx; urgency=medium

  * Fix: use https for downloading from mxrepo server
  * Clarify error message

 -- Adrian <adrian@mxlinux.org>  Fri, 18 Oct 2024 10:06:18 -0400

## mx-packageinstaller 24.11

=== debian/changelog ===
mx-packageinstaller (24.11) mx; urgency=medium

  * Check install recommended depends according to global settings
  * Update translations

 -- Adrian <adrian@mxlinux.org>  Fri, 08 Nov 2024 14:32:35 -0500

## mx-packageinstaller 24.11.01

=== debian/changelog ===
mx-packageinstaller (24.11.01) mx; urgency=medium

  * Fix: displaying number of packages when switching tabs
  * Fix: dispay info for packages from Enabled repos when browsing Test or
    Backport tabs

 -- Adrian <adrian@mxlinux.org>  Mon, 11 Nov 2024 02:02:31 -0500

## mx-packageinstaller 24.11.04

=== debian/changelog ===
mx-packageinstaller (24.11.04) mx; urgency=medium

  * Update flatpaks only if manually refreshed (list might show blank if flatpaks
    were never used on the system, but it's worth the time saving)
  * Fix displaying tab when rejecting flatpak installation

 -- Adrian <adrian@mxlinux.org>  Wed, 13 Nov 2024 16:12:21 -0500

## mx-packageinstaller 24.11.05

=== debian/changelog ===
mx-packageinstaller (24.11.05) mx; urgency=medium

  * Fix crash when switching tabs when there's text in the search field

 -- Adrian <adrian@mxlinux.org>  Thu, 14 Nov 2024 08:38:06 -0500

## mx-packageinstaller 24.11.06

=== debian/changelog ===
mx-packageinstaller (24.11.06) mx; urgency=medium

  * Fix deselecting checkboxes before installating the selected programs

 -- Adrian <adrian@mxlinux.org>  Thu, 14 Nov 2024 19:01:50 -0500

## mx-packageinstaller 24.12

=== debian/changelog ===
mx-packageinstaller (24.12) mx; urgency=medium

  * Display snapshots from screenshot.debian.net when clicking info icon in
    popular apps tab

 -- Adrian <adrian@mxlinux.org>  Sat, 14 Dec 2024 12:10:31 -0500

## mx-packageinstaller 24.12.01

=== debian/changelog ===
mx-packageinstaller (24.12.01) mx; urgency=medium

  * make mxpi-launcher a script rather than a symlink
  * addresses launch issue from apt-notifier 

 -- Dolphin Oracle <dolphinoracle@gmail.com>  Mon, 30 Dec 2024 16:52:59 -0500

## mx-packageinstaller 24.12.04

=== debian/changelog ===
mx-packageinstaller (24.12.04) mx; urgency=medium

  * Adjust regex to read binary-packages for current arch only and 
    add all flat-repo Packages without binary-arch in filename

 -- fehlix <fehlix@mxlinux.org>  Tue, 31 Dec 2024 11:12:36 -0500

mx-packageinstaller (24.12.03) mx; urgency=medium

  * adjust secondary regex to pick up more package lists

 -- Dolphin Oracle <dolphinoracle@gmail.com>  Tue, 31 Dec 2024 10:38:09 -0500

mx-packageinstaller (24.12.02) mx; urgency=medium

  * Set the application name to fix the Qt translation domain and
    window icon name based on the application name instead of the
    executable file or symlink name
  * Adjust regex for Packages filenames without binary-arch from flat-repo

 -- fehlix <fehlix@mxlinux.org>  Tue, 31 Dec 2024 10:19:35 -0500

## mx-packageinstaller 24.12.05

=== debian/changelog ===
mx-packageinstaller (24.12.05) mx; urgency=medium

  * Set version number during build from changelog within debian/rules

 -- fehlix <fehlix@mxlinux.org>  Tue, 31 Dec 2024 15:11:46 -0500

=== debian/rules ===
--- 
+++ 
@@ -24,4 +24,3 @@
 
 override_dh_auto_install:
 	dh_auto_install
-	dh_link usr/bin/mx-packageinstaller usr/bin/mxpi-launcher

## mx-packageinstaller 25.1

=== debian/changelog ===
mx-packageinstaller (25.1) mx; urgency=medium

  * Fix crash when switching back to Popular tab after searching in another
    tab
  * Minor optimizations
  * Update translations

 -- Adrian <adrian@mxlinux.org>  Mon, 20 Jan 2025 12:18:23 -0500

## mx-packageinstaller 25.2

=== debian/changelog ===
mx-packageinstaller (25.2) mx; urgency=medium

  * Minor change, check for mx.sources in addition to mx.list

 -- Adrian <adrian@mxlinux.org>  Tue, 11 Feb 2025 00:14:29 -0500

## mx-packageinstaller 25.2.01

=== debian/changelog ===
mx-packageinstaller (25.2.01) mx; urgency=medium

  * Add CTRL-F to change focus to search field

 -- Adrian <adrian@mxlinux.org>  Thu, 13 Feb 2025 12:53:23 -0500

## mx-packageinstaller 25.3

=== debian/changelog ===
mx-packageinstaller (25.3) mx; urgency=medium

  * Implements wildcard (*, ?) search

 -- Adrian <adrian@mxlinux.org>  Thu, 20 Mar 2025 09:19:36 -0400

## mx-packageinstaller 25.3.02

=== debian/changelog ===
mx-packageinstaller (25.3.02) mx; urgency=medium

  * Fix issue displaying an empty line in flatpak list
  * Fix performance issue when switching tabs after deselecting hide libs
    (still slower than normal, but it's functional now)
  * Clear some escape characters from output
  * Add busy cursor when loading the list 

 -- Adrian <adrian@mxlinux.org>  Fri, 28 Mar 2025 13:34:04 -0400

## mx-packageinstaller 25.5

=== debian/changelog ===
mx-packageinstaller (25.5) mx; urgency=medium

  * Update policy actions to run some commands without popping up an
    authentication dialog
  * Update translations

 -- Adrian <adrian@mxlinux.org>  Mon, 07 Apr 2025 22:28:43 -0400

## mx-packageinstaller 25.5.01

=== debian/changelog ===
mx-packageinstaller (25.5.01) mx; urgency=medium

  * Fix adding repo as user for flatpak

 -- Adrian <adrian@mxlinux.org>  Wed, 09 Apr 2025 21:04:51 -0400

=== debian/control ===
Source: mx-packageinstaller
Section: admin
Priority: optional
Maintainer: Adrian <adrian@mxlinux.org>
Build-Depends: debhelper (>=10), qtbase5-dev, qttools5-dev-tools
Standards-Version: 3.9.8
Vcs-Git: git://github.com/AdrianTM/mx-packageinstaller

Package: mx-packageinstaller
Architecture: any
Depends: aptitude,
         mx-packageinstaller-pkglist (>= 17.4),
         xdg-utils | mx-viewer,
         socat,
         ${misc:Depends},
         ${shlibs:Depends}
Recommends: flatpak (<< 1.0) | xdg-desktop-portal-gtk,
         flatpak (>= 0.8.9) [amd64]
Replaces: mx-debian-backports-installer,
          mx-package-manager,
          mx-package-manager-pkglist,
          mx-test-repo-installer
Provides: mx-debian-backports-installer, mx-test-repo-installer
Conflicts: mx-debian-backports-installer, mx-test-repo-installer
Description: MX Package Installer
 MX Package Installer is a tool used for managing packages on MX Linux
 - installs popular programs from different sources
 - installs programs from the MX Test repo
 - installs programs from Debian Backports repo
 - installs flatpaks

=== debian/rules ===
#!/usr/bin/make -f
export QT_SELECT=5

QMAKE_OPTS = DEFINES+=NO_DEBUG_ON_CONSOLE
MAKE_OPTS  = QMAKE=qmake-qt5 LRELEASE=lrelease-qt5 QMAKE_OPTS="$(QMAKE_OPTS)"

# Define version.h
VERSION_H = version.h

# Get version from debian/changelog
VERSION := $(shell dpkg-parsechangelog --show-field Version)

override_dh_auto_clean:
	dh_auto_clean
	rm -f translations/*.qm
	rm -f src/translations/*.qm

override_dh_auto_build:
	# Rename existing version.h to version.h~
	@echo "Renaming existing version.h to version.h~"
	@mv -f $(VERSION_H) $(VERSION_H)~ || true
	# Create new version.h with version from changelog
	@echo "Creating new version.h with version $(VERSION)"
	@echo "#define VERSION \"$(VERSION)\"" > $(VERSION_H)
	# Build
	lrelease translations/*.ts
	dh_auto_build -- $(MAKE_OPTS)

override_dh_auto_install:
	dh_auto_install -- $(MAKE_OPTS)

override_dh_shlibdeps:
	dh_shlibdeps -- -xvirtualbox-guest-x11 --ignore-missing-info

# Restore original version.h after build
override_dh_auto_clean:
	@echo "Restoring original version.h from version.h~"
	@mv -f $(VERSION_H)~ $(VERSION_H) || true
	dh_auto_clean

%:
	dh $@ --no-automatic-dbgsym --parallel

override_dh_auto_install:
	dh_auto_install

## mx-packageinstaller 25.6

=== debian/changelog ===
mx-packageinstaller (25.6) mx; urgency=medium

  * Don't assume debian version if it cannot be determined, open a
    dialog and ask user, if canceled, exit the app

 -- Adrian <adrian@mxlinux.org>  Tue, 17 Jun 2025 17:51:48 -0400

mx-packageinstaller (25.5.03) mx; urgency=medium

  * Update to Qt6
  * Update translations

 -- Adrian <adrian@mxlinux.org>  Wed, 23 Apr 2025 13:16:50 -0400

## mx-packageinstaller 25.6.01

=== debian/changelog ===
mx-packageinstaller (25.6.01) mx; urgency=medium

  * Fix localization

 -- Adrian <adrian@mxlinux.org>  Wed, 18 Jun 2025 20:56:55 -0400

## mx-packageinstaller 25.7

=== debian/changelog ===
mx-packageinstaller (25.7) mx; urgency=medium

  * Fix checkinstall function, selecting multiple installed packages
    should give the option to uninstall them

 -- Adrian <adrian@mxlinux.org>  Fri, 11 Jul 2025 12:13:33 -0400

## mx-packageinstaller 25.08

=== CMakeLists.txt ===
# **********************************************************************
# * Copyright (C) 2017 MX Authors
# *
# * Authors: Adrian
# *          Dolphin_Oracle
# *          MX Linux <http://mxlinux.org>
# *
# * This file is part of mx-packageinstaller.
# *
# * mx-packageinstaller is free software: you can redistribute it and/or modify
# * it under the terms of the GNU General Public License as published by
# * the Free Software Foundation, either version 3 of the License, or
# * (at your option) any later version.
# *
# * mx-packageinstaller is distributed in the hope that it will be useful,
# * but WITHOUT ANY WARRANTY; without even the implied warranty of
# * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# * GNU General Public License for more details.
# *
# * You should have received a copy of the GNU General Public License
# * along with mx-packageinstaller.  If not, see <http://www.gnu.org/licenses/>.
# **********************************************************************/

cmake_minimum_required(VERSION 3.16)

project(mx-packageinstaller
    VERSION 25.7
    DESCRIPTION "MX Package Installer - A tool for managing packages on MX Linux"
    LANGUAGES CXX
)

# Set C++ standard
set(CMAKE_CXX_STANDARD 20)
set(CMAKE_CXX_STANDARD_REQUIRED ON)

# Option to use clang for testing builds
option(USE_CLANG "Use clang compiler" OFF)
if(USE_CLANG)
    set(CMAKE_C_COMPILER clang)
    set(CMAKE_CXX_COMPILER clang++)
    set(CMAKE_CXX_COMPILER_ID "Clang")
    message(STATUS "Using clang compiler")
endif()

# Option to build tests
option(BUILD_TESTS "Build unit tests" OFF)

# Find Qt6 components
find_package(Qt6 REQUIRED COMPONENTS
    Core
    Gui
    Widgets
    Network
    Xml
    LinguistTools
)

# Enable automatic MOC, UIC, and RCC processing
set(CMAKE_AUTOMOC ON)
set(CMAKE_AUTOUIC ON)
set(CMAKE_AUTORCC ON)

# Define source files
set(SOURCES
    log.cpp
    main.cpp
    mainwindow.cpp
    lockfile.cpp
    versionnumber.cpp
    aptcache.cpp
    remotes.cpp
    about.cpp
    cmd.cpp
)

set(HEADERS
    log.h
    mainwindow.h
    lockfile.h
    versionnumber.h
    aptcache.h
    remotes.h
    about.h
    cmd.h
)

set(UI_FILES
    mainwindow.ui
)

set(RESOURCE_FILES
    images.qrc
)

set(TRANSLATION_FILES
    translations/mx-packageinstaller_en.ts
)

# Create the executable
add_executable(mx-packageinstaller
    ${SOURCES}
    ${HEADERS}
    ${UI_FILES}
    ${RESOURCE_FILES}
)

# Link Qt6 libraries
target_link_libraries(mx-packageinstaller
    Qt6::Core
    Qt6::Gui
    Qt6::Widgets
    Qt6::Network
    Qt6::Xml
)

# Set compiler flags
target_compile_options(mx-packageinstaller PRIVATE
    -Wpedantic
    -pedantic
    -Werror=return-type
    -Werror=switch
    -Werror=uninitialized
    -Werror
)

# Add compiler-specific flags
if(CMAKE_CXX_COMPILER_ID STREQUAL "Clang" OR USE_CLANG)
    target_compile_options(mx-packageinstaller PRIVATE -Werror=return-stack-address)
else()
    target_compile_options(mx-packageinstaller PRIVATE 
        -Werror=return-local-addr
        # Suppress false positive LTO warnings with Qt6 QHash (GCC only)
        -Wno-alloc-size-larger-than
    )
endif()

# Set compile definitions
target_compile_definitions(mx-packageinstaller PRIVATE
    QT_DEPRECATED_WARNINGS
    QT_DISABLE_DEPRECATED_BEFORE=0x060000
)

# Release-specific optimizations
if(CMAKE_BUILD_TYPE STREQUAL "Release")
    target_compile_definitions(mx-packageinstaller PRIVATE NDEBUG)
    target_compile_options(mx-packageinstaller PRIVATE -O3)
    
    # Only add LTO for GCC, not Clang
    if(NOT CMAKE_CXX_COMPILER_ID STREQUAL "Clang" AND NOT USE_CLANG)
        target_compile_options(mx-packageinstaller PRIVATE -flto=auto)
        target_link_options(mx-packageinstaller PRIVATE
            -flto=auto
            # Suppress false positive LTO warnings with Qt6 QHash at link time (GCC only)
            -Wno-alloc-size-larger-than
        )
    endif()
endif()

# Handle translations
qt6_add_translations(mx-packageinstaller
    TS_FILES ${TRANSLATION_FILES}
)

# Set target properties
set_target_properties(mx-packageinstaller PROPERTIES
    OUTPUT_NAME "mx-packageinstaller"
    RUNTIME_OUTPUT_DIRECTORY ${CMAKE_BINARY_DIR}
)

# Add tests if requested
if(BUILD_TESTS)
    message(STATUS "Building with tests enabled")
    add_subdirectory(tests)
endif()

=== tests/CMakeLists.txt ===
# Tests CMakeLists.txt for mx-packageinstaller
cmake_minimum_required(VERSION 3.16)
project(mx-packageinstaller-tests)

# Set C++ standard
set(CMAKE_CXX_STANDARD 20)
set(CMAKE_CXX_STANDARD_REQUIRED ON)

# Find Qt6 Test module
find_package(Qt6 REQUIRED COMPONENTS Test Core)

# Enable testing
enable_testing()

# Set up test include directories
include_directories(${CMAKE_CURRENT_SOURCE_DIR}/..)
set(CMAKE_AUTOMOC ON)

# Test for VersionNumber class
add_executable(test_versionnumber
    test_versionnumber.cpp
    ../versionnumber.cpp
)

target_link_libraries(test_versionnumber
    Qt6::Core
    Qt6::Test
)

target_compile_options(test_versionnumber PRIVATE
    -Wpedantic
    -pedantic
    -Werror=return-type
    -Werror=switch
    -Werror=uninitialized
)

# Add compiler-specific flags for tests
if(CMAKE_CXX_COMPILER_ID STREQUAL "Clang" OR USE_CLANG)
    target_compile_options(test_versionnumber PRIVATE -Werror=return-stack-address)
else()
    target_compile_options(test_versionnumber PRIVATE -Werror=return-local-addr)
endif()

add_test(NAME VersionNumberTest COMMAND test_versionnumber)

# Test for AptCache class
add_executable(test_aptcache
    test_aptcache.cpp
    ../aptcache.cpp
    ../versionnumber.cpp
)

target_link_libraries(test_aptcache
    Qt6::Core
    Qt6::Test
)

target_compile_options(test_aptcache PRIVATE
    -Wpedantic
    -pedantic
    -Werror=return-type
    -Werror=switch
    -Werror=uninitialized
)

# Add compiler-specific flags for tests
if(CMAKE_CXX_COMPILER_ID STREQUAL "Clang" OR USE_CLANG)
    target_compile_options(test_aptcache PRIVATE -Werror=return-stack-address)
else()
    target_compile_options(test_aptcache PRIVATE -Werror=return-local-addr)
endif()

add_test(NAME AptCacheTest COMMAND test_aptcache)

# Add convenience target to run all tests
add_custom_target(run_tests
    COMMAND ${CMAKE_CTEST_COMMAND} --verbose
    DEPENDS test_versionnumber test_aptcache
    COMMENT "Running all tests"
)

# Add file watching target for continuous testing
add_custom_target(watch_tests
    COMMAND echo "Starting continuous testing - press Ctrl+C to stop"
    COMMAND bash -c "while inotifywait -e modify -r ${CMAKE_CURRENT_SOURCE_DIR}/.. --include='.*\\.(cpp|h)$$' 2>/dev/null; do echo ''; echo '=== Files changed, rebuilding and testing ==='; ${CMAKE_COMMAND} --build ${CMAKE_BINARY_DIR} && ${CMAKE_CTEST_COMMAND} --verbose; done"
    COMMENT "Watch for file changes and auto-run tests"
    USES_TERMINAL
)

=== debian/changelog ===
mx-packageinstaller (25.08) mx; urgency=medium

  * Fix: detection for multiple packages

 -- Adrian <adrian@mxlinux.org>  Fri, 01 Aug 2025 11:57:07 -0400

=== debian/control ===
Source: mx-packageinstaller
Section: admin
Priority: optional
Maintainer: Adrian <adrian@mxlinux.org>
Build-Depends: debhelper-compat (= 13),
               qt6-base-dev,
               qt6-base-dev-tools,
               qt6-tools-dev,
               qt6-tools-dev-tools
Standards-Version: 3.9.8
Vcs-Git: git://github.com/MX-Linux/mx-packageinstaller
Homepage: https://github.com/MX-Linux/mx-packageinstaller

Package: mx-packageinstaller
Architecture: any
Depends: aptitude,
         mx-packageinstaller-pkglist (>= 17.4),
         xdg-utils | mx-viewer,
         socat,
         ${misc:Depends},
         ${shlibs:Depends}
Recommends: flatpak (<< 1.0) | xdg-desktop-portal-gtk,
         flatpak (>= 0.8.9) [amd64]
Replaces: mx-debian-backports-installer,
          mx-package-manager,
          mx-package-manager-pkglist,
          mx-test-repo-installer
Provides: mx-debian-backports-installer, mx-test-repo-installer
Conflicts: mx-debian-backports-installer, mx-test-repo-installer
Description: Package installation tool for MX Linux
 MX Package Installer is a graphical utility that allows users to easily
 install and manage software packages on MX Linux. It provides a user-friendly
 interface for:
  * Installing popular applications from various repositories
  * Managing packages from the MX Test repository
  * Installing software from Debian Backports
  * Installing and managing Flatpak applications
  * Simplifying package management without requiring command line knowledge

=== debian/rules ===
#!/usr/bin/make -f
export QT_SELECT=6

QMAKE_OPTS = DEFINES+=NO_DEBUG_ON_CONSOLE
MAKE_OPTS  = QMAKE=qmake6 QMAKE_OPTS="$(QMAKE_OPTS)"

override_dh_auto_configure:
	qmake6

override_dh_auto_clean:
	dh_auto_clean
	rm -f src/translations/*.qm

override_dh_auto_build:
	/usr/lib/qt6/bin/lrelease translations/*.ts
	head -n1 debian/changelog | sed -e "s/.*(\([^(]*\)).*/inline const QString VERSION {\"\1\"};/" > version.h
	dh_auto_build -- $(MAKE_OPTS)

override_dh_auto_install:
	dh_auto_install -- $(MAKE_OPTS)

override_dh_shlibdeps:
	dh_shlibdeps --dpkg-shlibdeps-params=--ignore-missing-info

%:
	dh $@ --no-automatic-dbgsym

## mx-packageinstaller 25.08.1

=== debian/changelog ===
mx-packageinstaller (25.08.1) mx; urgency=medium

  * Fix: adding flatpak repos for --user if not available
  * Performance improvements

 -- Adrian <adrian@mxlinux.org>  Sat, 02 Aug 2025 14:11:12 -0400

## mx-packageinstaller 25.08.2

=== CMakeLists.txt ===
--- 
+++ 
@@ -23,8 +23,21 @@
 
 cmake_minimum_required(VERSION 3.16)
 
+# Get version from debian/changelog
+execute_process(
+    COMMAND dpkg-parsechangelog -SVersion
+    WORKING_DIRECTORY ${CMAKE_SOURCE_DIR}
+    OUTPUT_VARIABLE PROJECT_VERSION_FROM_CHANGELOG
+    OUTPUT_STRIP_TRAILING_WHITESPACE
+    RESULT_VARIABLE DPKG_RESULT
+)
+
+if(NOT DPKG_RESULT EQUAL 0)
+    message(FATAL_ERROR "Failed to get version from debian/changelog using dpkg-parsechangelog")
+endif()
+
 project(mx-packageinstaller
-    VERSION 25.7
+    VERSION ${PROJECT_VERSION_FROM_CHANGELOG}
     DESCRIPTION "MX Package Installer - A tool for managing packages on MX Linux"
     LANGUAGES CXX
 )
@@ -32,6 +45,19 @@
 # Set C++ standard
 set(CMAKE_CXX_STANDARD 20)
 set(CMAKE_CXX_STANDARD_REQUIRED ON)
+
+# Enable compile commands export for IDEs and tools
+set(CMAKE_EXPORT_COMPILE_COMMANDS ON)
+
+# Optimize for Ninja builds
+if(CMAKE_GENERATOR STREQUAL "Ninja")
+    # Enable colored output for Ninja
+    if(CMAKE_CXX_COMPILER_ID STREQUAL "GNU")
+        add_compile_options(-fdiagnostics-color=always)
+    elseif(CMAKE_CXX_COMPILER_ID STREQUAL "Clang")
+        add_compile_options(-fcolor-diagnostics)
+    endif()
+endif()
 
 # Option to use clang for testing builds
 option(USE_CLANG "Use clang compiler" OFF)
@@ -62,39 +88,38 @@
 
 # Define source files
 set(SOURCES
-    log.cpp
-    main.cpp
-    mainwindow.cpp
-    lockfile.cpp
-    versionnumber.cpp
-    aptcache.cpp
-    remotes.cpp
-    about.cpp
-    cmd.cpp
+    src/log.cpp
+    src/main.cpp
+    src/mainwindow.cpp
+    src/lockfile.cpp
+    src/versionnumber.cpp
+    src/aptcache.cpp
+    src/remotes.cpp
+    src/about.cpp
+    src/cmd.cpp
 )
 
 set(HEADERS
-    log.h
-    mainwindow.h
-    lockfile.h
-    versionnumber.h
-    aptcache.h
-    remotes.h
-    about.h
-    cmd.h
+    src/log.h
+    src/mainwindow.h
+    src/lockfile.h
+    src/versionnumber.h
+    src/aptcache.h
+    src/remotes.h
+    src/about.h
+    src/cmd.h
 )
 
 set(UI_FILES
-    mainwindow.ui
+    src/mainwindow.ui
 )
 
 set(RESOURCE_FILES
     images.qrc
 )
 
-set(TRANSLATION_FILES
-    translations/mx-packageinstaller_en.ts
-)
+# Get all translation files
+file(GLOB TRANSLATION_FILES "translations/*.ts")
 
 # Create the executable
 add_executable(mx-packageinstaller
@@ -144,9 +169,12 @@
 if(CMAKE_BUILD_TYPE STREQUAL "Release")
     target_compile_definitions(mx-packageinstaller PRIVATE NDEBUG)
     target_compile_options(mx-packageinstaller PRIVATE -O3)
-    
-    # Only add LTO for GCC, not Clang
-    if(NOT CMAKE_CXX_COMPILER_ID STREQUAL "Clang" AND NOT USE_CLANG)
+
+    # Add LTO - different flags for different compilers
+    if(CMAKE_CXX_COMPILER_ID STREQUAL "Clang" OR USE_CLANG)
+        target_compile_options(mx-packageinstaller PRIVATE -flto=thin)
+        target_link_options(mx-packageinstaller PRIVATE -flto=thin)
+    else()
         target_compile_options(mx-packageinstaller PRIVATE -flto=auto)
         target_link_options(mx-packageinstaller PRIVATE
             -flto=auto
@@ -159,6 +187,7 @@
 # Handle translations
 qt6_add_translations(mx-packageinstaller
     TS_FILES ${TRANSLATION_FILES}
+    QM_FILES_OUTPUT_VARIABLE qm_files
 )
 
 # Set target properties
@@ -167,9 +196,15 @@
     RUNTIME_OUTPUT_DIRECTORY ${CMAKE_BINARY_DIR}
 )
 
+# Install target (required by Debian build system)
+# Other files are handled by debian/install
+install(TARGETS mx-packageinstaller
+    RUNTIME DESTINATION bin
+)
+
 # Add tests if requested
 if(BUILD_TESTS)
     message(STATUS "Building with tests enabled")
-    add_subdirectory(tests)
-endif()
-
+    add_subdirectory(Testing)
+endif()
+

=== debian/changelog ===
mx-packageinstaller (25.08.2) mx; urgency=medium

  * Fix VersionNumber comparison to match dpkg semantics

 -- Adrian <adrian@mxlinux.org>  Wed, 20 Aug 2025 16:51:35 -0400

## mx-packageinstaller 25.09

=== debian/changelog ===
mx-packageinstaller (25.09) mx; urgency=medium

  * Remember HideLibs selection
  * Add a select all checkbox for 'Upgradable' and 'Autoremovable'
    filters

 -- Adrian <adrian@mxlinux.org>  Fri, 05 Sep 2025 12:02:47 -0400

=== debian/control ===
--- 
+++ 
@@ -3,6 +3,8 @@
 Priority: optional
 Maintainer: Adrian <adrian@mxlinux.org>
 Build-Depends: debhelper-compat (= 13),
+               cmake (>= 3.16),
+               ninja-build,
                qt6-base-dev,
                qt6-base-dev-tools,
                qt6-tools-dev,

## mx-packageinstaller 25.09.1

=== CMakeLists.txt ===
--- 
+++ 
@@ -1,5 +1,5 @@
 # **********************************************************************
-# * Copyright (C) 2017 MX Authors
+# * Copyright (C) 2017-2025 MX Authors
 # *
 # * Authors: Adrian
 # *          Dolphin_Oracle
@@ -23,17 +23,35 @@
 
 cmake_minimum_required(VERSION 3.16)
 
-# Get version from debian/changelog
-execute_process(
-    COMMAND dpkg-parsechangelog -SVersion
-    WORKING_DIRECTORY ${CMAKE_SOURCE_DIR}
-    OUTPUT_VARIABLE PROJECT_VERSION_FROM_CHANGELOG
-    OUTPUT_STRIP_TRAILING_WHITESPACE
-    RESULT_VARIABLE DPKG_RESULT
-)
-
-if(NOT DPKG_RESULT EQUAL 0)
-    message(FATAL_ERROR "Failed to get version from debian/changelog using dpkg-parsechangelog")
+# Allow selecting clang before project() to ensure proper toolchain detection
+option(USE_CLANG "Use clang compiler" OFF)
+if(USE_CLANG)
+    set(CMAKE_C_COMPILER clang)
+    set(CMAKE_CXX_COMPILER clang++)
+    message(STATUS "Using clang compiler")
+endif()
+
+# Version detection with override and fallback
+set(PROJECT_VERSION_OVERRIDE "" CACHE STRING "Override project version (e.g. 1.2.3)")
+set(PROJECT_VERSION_FROM_CHANGELOG "")
+find_program(DPKG_PARSECHANGELOG_EXECUTABLE NAMES dpkg-parsechangelog)
+if(PROJECT_VERSION_OVERRIDE)
+    set(PROJECT_VERSION_FROM_CHANGELOG ${PROJECT_VERSION_OVERRIDE})
+elseif(DPKG_PARSECHANGELOG_EXECUTABLE)
+    execute_process(
+        COMMAND ${DPKG_PARSECHANGELOG_EXECUTABLE} -SVersion
+        WORKING_DIRECTORY ${CMAKE_SOURCE_DIR}
+        OUTPUT_VARIABLE PROJECT_VERSION_FROM_CHANGELOG
+        OUTPUT_STRIP_TRAILING_WHITESPACE
+        RESULT_VARIABLE DPKG_RESULT
+    )
+    if(NOT DPKG_RESULT EQUAL 0 OR PROJECT_VERSION_FROM_CHANGELOG STREQUAL "")
+        set(PROJECT_VERSION_FROM_CHANGELOG "0.0.0")
+        message(WARNING "Failed to get version from debian/changelog; defaulting to ${PROJECT_VERSION_FROM_CHANGELOG}")
+    endif()
+else()
+    set(PROJECT_VERSION_FROM_CHANGELOG "0.0.0")
+    message(WARNING "dpkg-parsechangelog not found; defaulting to ${PROJECT_VERSION_FROM_CHANGELOG}")
 endif()
 
 project(mx-packageinstaller
@@ -59,15 +77,6 @@
     endif()
 endif()
 
-# Option to use clang for testing builds
-option(USE_CLANG "Use clang compiler" OFF)
-if(USE_CLANG)
-    set(CMAKE_C_COMPILER clang)
-    set(CMAKE_CXX_COMPILER clang++)
-    set(CMAKE_CXX_COMPILER_ID "Clang")
-    message(STATUS "Using clang compiler")
-endif()
-
 # Option to build tests
 option(BUILD_TESTS "Build unit tests" OFF)
 
@@ -91,6 +100,7 @@
     src/log.cpp
     src/main.cpp
     src/mainwindow.cpp
+    src/checkableheaderview.cpp
     src/lockfile.cpp
     src/versionnumber.cpp
     src/aptcache.cpp
@@ -102,6 +112,7 @@
 set(HEADERS
     src/log.h
     src/mainwindow.h
+    src/checkableheaderview.h
     src/lockfile.h
     src/versionnumber.h
     src/aptcache.h
@@ -115,7 +126,7 @@
 )
 
 set(RESOURCE_FILES
-    images.qrc
+    src/images.qrc
 )
 
 # Get all translation files
@@ -152,7 +163,7 @@
 if(CMAKE_CXX_COMPILER_ID STREQUAL "Clang" OR USE_CLANG)
     target_compile_options(mx-packageinstaller PRIVATE -Werror=return-stack-address)
 else()
-    target_compile_options(mx-packageinstaller PRIVATE 
+    target_compile_options(mx-packageinstaller PRIVATE
         -Werror=return-local-addr
         # Suppress false positive LTO warnings with Qt6 QHash (GCC only)
         -Wno-alloc-size-larger-than
@@ -163,6 +174,7 @@
 target_compile_definitions(mx-packageinstaller PRIVATE
     QT_DEPRECATED_WARNINGS
     QT_DISABLE_DEPRECATED_BEFORE=0x060000
+    VERSION="${PROJECT_VERSION}"
 )
 
 # Release-specific optimizations
@@ -187,6 +199,7 @@
 # Handle translations
 qt6_add_translations(mx-packageinstaller
     TS_FILES ${TRANSLATION_FILES}
+    LRELEASE_OPTIONS -compress -nounfinished -removeidentical -silent
     QM_FILES_OUTPUT_VARIABLE qm_files
 )
 
@@ -207,4 +220,3 @@
     message(STATUS "Building with tests enabled")
     add_subdirectory(Testing)
 endif()
-

=== Testing/CMakeLists.txt ===
# Tests CMakeLists.txt for mx-packageinstaller
cmake_minimum_required(VERSION 3.16)
project(mx-packageinstaller-tests)

# Set C++ standard
set(CMAKE_CXX_STANDARD 20)
set(CMAKE_CXX_STANDARD_REQUIRED ON)

# Find Qt6 Test module
find_package(Qt6 REQUIRED COMPONENTS Test Core)

# Enable testing
enable_testing()

# Set up test include directories
include_directories(${CMAKE_CURRENT_SOURCE_DIR}/..)
set(CMAKE_AUTOMOC ON)

# Test for VersionNumber class
add_executable(test_versionnumber
    test_versionnumber.cpp
    ../src/versionnumber.cpp
)

target_link_libraries(test_versionnumber
    Qt6::Core
    Qt6::Test
)

target_compile_options(test_versionnumber PRIVATE
    -Wpedantic
    -pedantic
    -Werror=return-type
    -Werror=switch
    -Werror=uninitialized
)

# Add compiler-specific flags for tests
if(CMAKE_CXX_COMPILER_ID STREQUAL "Clang" OR USE_CLANG)
    target_compile_options(test_versionnumber PRIVATE -Werror=return-stack-address)
else()
    target_compile_options(test_versionnumber PRIVATE -Werror=return-local-addr)
endif()

add_test(NAME VersionNumberTest COMMAND test_versionnumber)

# Test for AptCache class
add_executable(test_aptcache
    test_aptcache.cpp
    ../src/aptcache.cpp
    ../src/versionnumber.cpp
)

target_link_libraries(test_aptcache
    Qt6::Core
    Qt6::Test
)

target_compile_options(test_aptcache PRIVATE
    -Wpedantic
    -pedantic
    -Werror=return-type
    -Werror=switch
    -Werror=uninitialized
)

# Add compiler-specific flags for tests
if(CMAKE_CXX_COMPILER_ID STREQUAL "Clang" OR USE_CLANG)
    target_compile_options(test_aptcache PRIVATE -Werror=return-stack-address)
else()
    target_compile_options(test_aptcache PRIVATE -Werror=return-local-addr)
endif()

add_test(NAME AptCacheTest COMMAND test_aptcache)

# Add convenience target to run all tests
add_custom_target(run_tests
    COMMAND ${CMAKE_CTEST_COMMAND} --verbose
    DEPENDS test_versionnumber test_aptcache
    COMMENT "Running all tests"
)

# Add file watching target for continuous testing
add_custom_target(watch_tests
    COMMAND echo "Starting continuous testing - press Ctrl+C to stop"
    COMMAND bash -c "while inotifywait -e modify -r ${CMAKE_CURRENT_SOURCE_DIR}/.. --include='.*\\.(cpp|h)$$' 2>/dev/null; do echo ''; echo '=== Files changed, rebuilding and testing ==='; ${CMAKE_COMMAND} --build ${CMAKE_BINARY_DIR} && ${CMAKE_CTEST_COMMAND} --verbose; done"
    COMMENT "Watch for file changes and auto-run tests"
    USES_TERMINAL
)

=== debian/changelog ===
mx-packageinstaller (25.09.1) mx; urgency=medium

  * Performance fix: select all checkboxes in a batch manner
  * Add sudo as backup to pkexec -- but it would only work if ran from
    CLI
  * Minor interface fix, display message first and then switch to
    Popular tab

 -- Adrian <adrian@mxlinux.org>  Thu, 11 Sep 2025 15:29:22 -0400

=== debian/control ===
--- 
+++ 
@@ -18,6 +18,7 @@
 Depends: aptitude,
          mx-packageinstaller-pkglist (>= 17.4),
          xdg-utils | mx-viewer,
+         sudo | pkexec | gksu,
          socat,
          ${misc:Depends},
          ${shlibs:Depends}

=== debian/rules ===
#!/usr/bin/make -f
export QT_SELECT=6

override_dh_auto_configure:
	dh_auto_configure -- \
		-G Ninja \
		-DCMAKE_BUILD_TYPE=Release \
		-DCMAKE_EXPORT_COMPILE_COMMANDS=ON

override_dh_auto_clean:
	dh_auto_clean
	rm -rf build/
	rm -f translations/*.qm

override_dh_shlibdeps:
	dh_shlibdeps --dpkg-shlibdeps-params=--ignore-missing-info

override_dh_auto_test:
	# Skip tests in Debian build - tests can be run manually with cmake --build build --target run_tests

override_dh_auto_install:
	# Install is handled by debian/install file
	dh_auto_install

%:
	dh $@ --buildsystem=cmake+ninja --no-automatic-dbgsym

## mx-packageinstaller 25.12

=== debian/changelog ===
mx-packageinstaller (25.12) mx; urgency=medium

  * Move .Platform packages from Apps to Runtime Flatpak category

 -- Adrian <adrian@mxlinux.org>  Tue, 02 Dec 2025 10:55:41 -0500

## mx-packageinstaller 25.12.4

=== debian/changelog ===
mx-packageinstaller (25.12.4) mx; urgency=medium

  * Cache flatpak listings and normalize refs for user scope
  * List flatpak versions that were removed from repos
  * Autoajust flatpak columns
  * Ensure user flatpak remotes are initialized when switching scope
  * Cache flatpak remote listing to avoid duplicate remote-ls on tab switch
  * Show Flatpak branch column on pre-Trixie Debian
  * UI improvements: progress bar should not flash anymore

 -- Adrian <adrian@mxlinux.org>  Thu, 04 Dec 2025 17:27:25 -0500

## mx-packageinstaller 26.01

=== debian/changelog ===
mx-packageinstaller (26.01) mx; urgency=medium

  * Make legend icons non-interactive
  * Fix network check reply cleanup
  * Filter ANSI cursor queries from output
  * Collapse flatpak progress lines

 -- Adrian <adrian@mxlinux.org>  Mon, 05 Jan 2026 12:33:59 -0500

## mx-packageinstaller 26.01.3

=== CMakeLists.txt ===
--- 
+++ 
@@ -33,30 +33,39 @@
 
 # Version detection with override and fallback
 set(PROJECT_VERSION_OVERRIDE "" CACHE STRING "Override project version (e.g. 1.2.3)")
-set(PROJECT_VERSION_FROM_CHANGELOG "")
-find_program(DPKG_PARSECHANGELOG_EXECUTABLE NAMES dpkg-parsechangelog)
-if(PROJECT_VERSION_OVERRIDE)
-    set(PROJECT_VERSION_FROM_CHANGELOG ${PROJECT_VERSION_OVERRIDE})
-elseif(DPKG_PARSECHANGELOG_EXECUTABLE)
-    execute_process(
-        COMMAND ${DPKG_PARSECHANGELOG_EXECUTABLE} -SVersion
-        WORKING_DIRECTORY ${CMAKE_SOURCE_DIR}
-        OUTPUT_VARIABLE PROJECT_VERSION_FROM_CHANGELOG
-        OUTPUT_STRIP_TRAILING_WHITESPACE
-        RESULT_VARIABLE DPKG_RESULT
-    )
-    if(NOT DPKG_RESULT EQUAL 0 OR PROJECT_VERSION_FROM_CHANGELOG STREQUAL "")
-        set(PROJECT_VERSION_FROM_CHANGELOG "0.0.0")
-        message(WARNING "Failed to get version from debian/changelog; defaulting to ${PROJECT_VERSION_FROM_CHANGELOG}")
+set(PROJECT_VERSION_FROM_METADATA "")
+
+if(DEFINED PROJECT_VERSION_OVERRIDE AND NOT "${PROJECT_VERSION_OVERRIDE}" STREQUAL "")
+    set(PROJECT_VERSION_FROM_METADATA "${PROJECT_VERSION_OVERRIDE}")
+    message(STATUS "Using version override: ${PROJECT_VERSION_FROM_METADATA}")
+elseif(EXISTS ${CMAKE_SOURCE_DIR}/PKGBUILD)
+    file(READ ${CMAKE_SOURCE_DIR}/PKGBUILD PROJECT_PKGBUILD_CONTENT)
+    string(REGEX MATCH "(^|[\r\n])[ \t]*pkgver=([^ \t\r\n]+)" _pkgver_match "${PROJECT_PKGBUILD_CONTENT}")
+    set(PROJECT_PKGBUILD_VER "${CMAKE_MATCH_2}")
+    string(REGEX MATCH "(^|[\r\n])[ \t]*pkgrel=([^ \t\r\n]+)" _pkgrel_match "${PROJECT_PKGBUILD_CONTENT}")
+    set(PROJECT_PKGBUILD_REL "${CMAKE_MATCH_2}")
+    if(_pkgver_match)
+        # Support pkgver=${PKGVER:-<version>} default syntax
+        string(REGEX MATCH "^\\$\\{PKGVER:-([^}]+)\\}$" _pkgver_default_match "${PROJECT_PKGBUILD_VER}")
+        if(_pkgver_default_match)
+            set(PROJECT_PKGBUILD_VER "${CMAKE_MATCH_1}")
+        endif()
+        set(PROJECT_VERSION_FROM_METADATA "${PROJECT_PKGBUILD_VER}")
+        if(_pkgrel_match)
+            set(PROJECT_VERSION_PKGREL "${PROJECT_PKGBUILD_REL}")
+        endif()
+        message(STATUS "Using version from PKGBUILD: ${PROJECT_VERSION_FROM_METADATA}")
     endif()
-else()
-    set(PROJECT_VERSION_FROM_CHANGELOG "0.0.0")
-    message(WARNING "dpkg-parsechangelog not found; defaulting to ${PROJECT_VERSION_FROM_CHANGELOG}")
+endif()
+
+if("${PROJECT_VERSION_FROM_METADATA}" STREQUAL "")
+    message(WARNING "Could not determine version; defaulting to 0.0.0")
+    set(PROJECT_VERSION_FROM_METADATA "0.0.0")
 endif()
 
 project(mx-packageinstaller
-    VERSION ${PROJECT_VERSION_FROM_CHANGELOG}
-    DESCRIPTION "MX Package Installer - A tool for managing packages on MX Linux"
+    VERSION ${PROJECT_VERSION_FROM_METADATA}
+    DESCRIPTION "MX Package Installer - A tool for managing packages on Arch Linux"
     LANGUAGES CXX
 )
 
@@ -86,7 +95,6 @@
     Gui
     Widgets
     Network
-    Xml
     LinguistTools
 )
 
@@ -103,7 +111,6 @@
     src/checkableheaderview.cpp
     src/lockfile.cpp
     src/versionnumber.cpp
-    src/aptcache.cpp
     src/remotes.cpp
     src/about.cpp
     src/cmd.cpp
@@ -115,7 +122,6 @@
     src/checkableheaderview.h
     src/lockfile.h
     src/versionnumber.h
-    src/aptcache.h
     src/remotes.h
     src/about.h
     src/cmd.h
@@ -146,7 +152,6 @@
     Qt6::Gui
     Qt6::Widgets
     Qt6::Network
-    Qt6::Xml
 )
 
 # Set compiler flags
@@ -209,11 +214,22 @@
     RUNTIME_OUTPUT_DIRECTORY ${CMAKE_BINARY_DIR}
 )
 
-# Install target (required by Debian build system)
-# Other files are handled by debian/install
 install(TARGETS mx-packageinstaller
     RUNTIME DESTINATION bin
 )
+
+# Install desktop file
+install(FILES mx-packageinstaller.desktop DESTINATION share/applications)
+
+# Install icons
+install(FILES icons/mx-packageinstaller.svg DESTINATION share/icons/hicolor/scalable/apps)
+install(FILES icons/mx-packageinstaller.png DESTINATION share/icons/hicolor/48x48/apps)
+
+# Install translations
+install(FILES ${qm_files} DESTINATION share/locale/)
+
+# Install help files
+install(DIRECTORY help/ DESTINATION share/doc/mx-packageinstaller)
 
 # Add tests if requested
 if(BUILD_TESTS)

=== Testing/CMakeLists.txt ===
--- 
+++ 
@@ -7,7 +7,7 @@
 set(CMAKE_CXX_STANDARD_REQUIRED ON)
 
 # Find Qt6 Test module
-find_package(Qt6 REQUIRED COMPONENTS Test Core)
+find_package(Qt6 REQUIRED COMPONENTS Test Core Widgets)
 
 # Enable testing
 enable_testing()
@@ -73,10 +73,182 @@
 
 add_test(NAME AptCacheTest COMMAND test_aptcache)
 
+# Test for PackageModel class
+add_executable(test_packagemodel
+    test_packagemodel.cpp
+    ../src/models/packagemodel.cpp
+)
+
+target_link_libraries(test_packagemodel
+    Qt6::Core
+    Qt6::Test
+    Qt6::Widgets
+)
+
+target_compile_options(test_packagemodel PRIVATE
+    -Wpedantic
+    -pedantic
+    -Werror=return-type
+    -Werror=switch
+    -Werror=uninitialized
+)
+
+if(CMAKE_CXX_COMPILER_ID STREQUAL "Clang" OR USE_CLANG)
+    target_compile_options(test_packagemodel PRIVATE -Werror=return-stack-address)
+else()
+    target_compile_options(test_packagemodel PRIVATE -Werror=return-local-addr)
+endif()
+
+add_test(NAME PackageModelTest COMMAND test_packagemodel)
+
+# Test for FlatpakModel class
+add_executable(test_flatpakmodel
+    test_flatpakmodel.cpp
+    ../src/models/flatpakmodel.cpp
+)
+
+target_link_libraries(test_flatpakmodel
+    Qt6::Core
+    Qt6::Test
+    Qt6::Widgets
+)
+
+target_compile_options(test_flatpakmodel PRIVATE
+    -Wpedantic
+    -pedantic
+    -Werror=return-type
+    -Werror=switch
+    -Werror=uninitialized
+)
+
+if(CMAKE_CXX_COMPILER_ID STREQUAL "Clang" OR USE_CLANG)
+    target_compile_options(test_flatpakmodel PRIVATE -Werror=return-stack-address)
+else()
+    target_compile_options(test_flatpakmodel PRIVATE -Werror=return-local-addr)
+endif()
+
+add_test(NAME FlatpakModelTest COMMAND test_flatpakmodel)
+
+# Test for PackageFilterProxy class
+add_executable(test_packagefilterproxy
+    test_packagefilterproxy.cpp
+    ../src/models/packagemodel.cpp
+    ../src/models/packagefilterproxy.cpp
+)
+
+target_link_libraries(test_packagefilterproxy
+    Qt6::Core
+    Qt6::Test
+    Qt6::Widgets
+)
+
+target_compile_options(test_packagefilterproxy PRIVATE
+    -Wpedantic
+    -pedantic
+    -Werror=return-type
+    -Werror=switch
+    -Werror=uninitialized
+)
+
+if(CMAKE_CXX_COMPILER_ID STREQUAL "Clang" OR USE_CLANG)
+    target_compile_options(test_packagefilterproxy PRIVATE -Werror=return-stack-address)
+else()
+    target_compile_options(test_packagefilterproxy PRIVATE -Werror=return-local-addr)
+endif()
+
+add_test(NAME PackageFilterProxyTest COMMAND test_packagefilterproxy)
+
+# Test for FlatpakFilterProxy class
+add_executable(test_flatpakfilterproxy
+    test_flatpakfilterproxy.cpp
+    ../src/models/flatpakmodel.cpp
+    ../src/models/flatpakfilterproxy.cpp
+)
+
+target_link_libraries(test_flatpakfilterproxy
+    Qt6::Core
+    Qt6::Test
+    Qt6::Widgets
+)
+
+target_compile_options(test_flatpakfilterproxy PRIVATE
+    -Wpedantic
+    -pedantic
+    -Werror=return-type
+    -Werror=switch
+    -Werror=uninitialized
+)
+
+if(CMAKE_CXX_COMPILER_ID STREQUAL "Clang" OR USE_CLANG)
+    target_compile_options(test_flatpakfilterproxy PRIVATE -Werror=return-stack-address)
+else()
+    target_compile_options(test_flatpakfilterproxy PRIVATE -Werror=return-local-addr)
+endif()
+
+add_test(NAME FlatpakFilterProxyTest COMMAND test_flatpakfilterproxy)
+
+# Test for PopularModel class
+add_executable(test_popularmodel
+    test_popularmodel.cpp
+    ../src/models/popularmodel.cpp
+)
+
+target_link_libraries(test_popularmodel
+    Qt6::Core
+    Qt6::Test
+    Qt6::Widgets
+)
+
+target_compile_options(test_popularmodel PRIVATE
+    -Wpedantic
+    -pedantic
+    -Werror=return-type
+    -Werror=switch
+    -Werror=uninitialized
+)
+
+if(CMAKE_CXX_COMPILER_ID STREQUAL "Clang" OR USE_CLANG)
+    target_compile_options(test_popularmodel PRIVATE -Werror=return-stack-address)
+else()
+    target_compile_options(test_popularmodel PRIVATE -Werror=return-local-addr)
+endif()
+
+add_test(NAME PopularModelTest COMMAND test_popularmodel)
+
+# Test for PopularFilterProxy class
+add_executable(test_popularfilterproxy
+    test_popularfilterproxy.cpp
+    ../src/models/popularmodel.cpp
+    ../src/models/popularfilterproxy.cpp
+)
+
+target_link_libraries(test_popularfilterproxy
+    Qt6::Core
+    Qt6::Test
+    Qt6::Widgets
+)
+
+target_compile_options(test_popularfilterproxy PRIVATE
+    -Wpedantic
+    -pedantic
+    -Werror=return-type
+    -Werror=switch
+    -Werror=uninitialized
+)
+
+if(CMAKE_CXX_COMPILER_ID STREQUAL "Clang" OR USE_CLANG)
+    target_compile_options(test_popularfilterproxy PRIVATE -Werror=return-stack-address)
+else()
+    target_compile_options(test_popularfilterproxy PRIVATE -Werror=return-local-addr)
+endif()
+
+add_test(NAME PopularFilterProxyTest COMMAND test_popularfilterproxy)
+
 # Add convenience target to run all tests
 add_custom_target(run_tests
     COMMAND ${CMAKE_CTEST_COMMAND} --verbose
-    DEPENDS test_versionnumber test_aptcache
+    DEPENDS test_versionnumber test_aptcache test_packagemodel test_flatpakmodel
+            test_packagefilterproxy test_flatpakfilterproxy test_popularmodel test_popularfilterproxy
     COMMENT "Running all tests"
 )

=== debian/changelog ===
mx-packageinstaller (26.01.3) mx; urgency=medium

  * Fix version comparison

 -- Adrian <adrian@mxlinux.org>  Mon, 19 Jan 2026 22:33:15 -0500

mx-packageinstaller (26.01.2) mx; urgency=medium

  * Refactored code: app should use about 50MB less and be more responsive
  * Added check for elevation

 -- Adrian <adrian@mxlinux.org>  Mon, 19 Jan 2026 15:55:11 -0500

## mx-packageinstaller 26.01.4

=== debian/changelog ===
mx-packageinstaller (26.01.4) mx; urgency=medium

  * Performance fix: switching tabs should work better
  * Fix hide/show libs for MX Test and Backports tabs

 -- Adrian <adrian@mxlinux.org>  Wed, 21 Jan 2026 11:35:24 -0500

## mx-packageinstaller 26.01.5

=== debian/changelog ===
mx-packageinstaller (26.01.5) mx; urgency=medium

  * Make culumns in Popular tab resizable

 -- Adrian <adrian@mxlinux.org>  Fri, 23 Jan 2026 10:17:18 -0500

## mx-packageinstaller 26.01.6

=== debian/changelog ===
mx-packageinstaller (26.01.6) mx; urgency=medium

  * Fix for XRDP sessions

 -- Adrian <adrian@mxlinux.org>  Sat, 24 Jan 2026 08:06:01 -0500
